import 'package:widgets/load_state_layout.dart';

class NewsfeedDetailState {
  //页面 LoadView 状态的展示
  LoadState loadingState;
  String? errorMessage;

  int? page;
  int? limit = 10;
  int? count = 1;

  // 评论框信息
  Map<String, dynamic>? commentFieldInfo;

  Map<String, dynamic> detailInfo;
  List<Map<String, dynamic>> list; // 评论列表

  NewsfeedDetailState({
    this.loadingState = LoadState.State_Loading,
    String? errorMessage,
    this.page = 1,
    this.limit = 10,
    this.count = 1,
    Map<String, dynamic>? commentFieldInfo,
    required this.detailInfo,
    required this.list,
  }): commentFieldInfo = commentFieldInfo ?? {},
      errorMessage = errorMessage?? '';

  NewsfeedDetailState copyWith({
    LoadState? loadingState,
    String? errorMessage,
    int? page,
    int? limit,
    int? count,
    Map<String, dynamic>? detailInfo,
    Map<String, dynamic>? commentFieldInfo,
    List<Map<String, dynamic>>? list,
  }) {
    return NewsfeedDetailState(
      loadingState: loadingState ?? this.loadingState,
      errorMessage: errorMessage ?? this.errorMessage,
      page: page ?? this.page,
      limit: limit ?? this.limit,
      count: count ?? this.count,
      commentFieldInfo: commentFieldInfo ?? this.commentFieldInfo,
      detailInfo: detailInfo ?? this.detailInfo,
      list: list ?? this.list,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'loadingState': this.loadingState,
      'errorMessage': this.errorMessage,
      'page': this.page,
      'limit': this.limit,
      'count': this.count,
      'commentFieldInfo': this.commentFieldInfo,
      'detailInfo': this.detailInfo,
      'list': this.list,
    };
  }

  factory NewsfeedDetailState.fromMap(Map<String, dynamic> map) {
    return NewsfeedDetailState(
      loadingState: map['loadingState'] as LoadState,
      errorMessage: map['errorMessage'] as String,
      page: map['page'] as int,
      limit: map['limit'] as int,
      count: map['count'] as int,
      commentFieldInfo: map['commentFieldInfo'] as Map<String, dynamic>,
      detailInfo: map['detailInfo'] as Map<String, dynamic>,
      list: map['list'] as List<Map<String, dynamic>>,
    );
  }
}