import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:widgets/load_state_layout.dart';

import 'form_detail_state.dart';

part 'form_detail_view_model.g.dart';

@riverpod
class FormDetailViewModel extends _$FormDetailViewModel {
  @override
  FormDetailState build() {
    return FormDetailState();
  }

  void retryRequest() {
    fetchFormDetail();
  }

  //获取表单的详情数据
  void fetchFormDetail() async {
    //显示加载数据
    state = state.copyWith(loadingState: LoadState.State_Loading);

    await Future.delayed(const Duration(milliseconds: 1500));

    //根据后端返回的数据赋值状态
    state = state.copyWith(loadingState: LoadState.State_Success, status: 2);


  }
}
