import 'package:domain/entity/auth_login_entity.dart';
import 'package:domain/entity/server_time.dart';
import 'package:plugin_platform/platform_export.dart';
import 'package:plugin_platform/http/dio_engine.dart';
import 'package:plugin_platform/http/http_result.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:shared/utils/util.dart';

import '../constants/api_constants.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:plugin_basic/provider/http_provider/http_provider.dart';

part 'main_repository.g.dart';

@Riverpod(keepAlive: true)
MainRepository mainRepository(Ref ref) {
  final dioEngine = ref.watch(dioEngineProvider);
  return MainRepository(dioEngine: dioEngine);
}

/*
 * 首页的数据仓库
 */
class MainRepository {
  DioEngine dioEngine;

  MainRepository({required this.dioEngine});


}
